#ifndef DOUBLYLINKEDLIST_H
#define DOUBLYLINKEDLIST_H

#include <assert.h>

template <typename T>
struct Node {
    T data;
    Node<T> *next;
    Node<T> *prev;

    Node(T data) {
        this->data = data;
        next = nullptr;
        prev = nullptr;
    }
};

template <typename T>
class DoublyLinkedList {
 private:
        Node<T> *head;
        Node<T> *tail;
        int numElements;

        /**
         * Returns the pos'th node in the list.
         */
        Node<T> *goToPos(int pos) {
            int count = 0;
            Node<T> *temp = head;

            while (count != pos) {
                temp = temp->next;
                count++;
            }

            return temp;
        }

 public:
        // Constructor
        DoublyLinkedList() {
            head = nullptr;
            tail = nullptr;
            numElements = 0;
        }

        // Another constructor
        DoublyLinkedList(Node<T> *head) {
            this->head = head;
            while (head != nullptr) {
                numElements++;
                head = head->next;
            }
        }

        // Destructor
        ~DoublyLinkedList() {
            // TODO: delete previously allocated stuff (if any)
        }

        /**
         * Adds a new node at the end of the list.
         */
        void addLast(T data) {
            // TODO: implement
        }

        /**
         * Adds a new node at the beginning of the list.
         */
        void addFirst(T data) {
            // TODO: implement
        }

        /**
         * Removes the last node of the list.
         */
        T removeLast() {
            // TODO: implement
        }

        /**
         * Removes the first node of the list.
         */
        T removeFirst() {
            // TODO: implement
        }

        /**
         * Check if the list contains any elements.
         */
        bool isEmpty() {
            // TODO: implement
        }

        /**
         * Returns the number of nodes in the list.
         */
        int size() {
            // TODO: implement
        }

        /**
         * Adds a new node on the specified position in the list.
         */
        void addOnPos(T element, int pos) {
            // TODO: implement
        }

        /**
         * Removes the node on the specified position and returns the value it stored.
         */
        T removeFromPos(int pos) {
            // TODO: implement
        }

        // Getters & Setters
        Node<T> *getHead() {
            return head;
        }

        Node<T> *getTail() {
            return tail;
        }

        template <typename U>
        friend std::ostream& operator<<(std::ostream& os,
                DoublyLinkedList<U>& list);
};

template <typename T>
std::ostream& operator<<(std::ostream& os, DoublyLinkedList<T>& list) {
    Node<T> *it = list.getHead();

    if (list.size() > 0) {
        os << "[ ";
        while (it->next != nullptr) {
            os << it->data << " <-> ";
            it = it->next;
        }

        os << it->data;
        os << " ]";
    } else {
        os << "[]";
    }

    return os;
}

#endif  // DOUBLYLINKEDLIST_H
