#ifndef SLIDINGWINDOW_H
#define SLIDINGWINDOW_H

#include <vector>

#include "DoublyLinkedList.h"

template <typename T>
class SlidingWindow {
 public:
        /**
         * Constructor. Initializes a new sliding window
         * based on the given vector. The window
         * will contain at most `capacity` elements.
         */
        SlidingWindow(const std::vector<T> container, int capacity) {
            // TODO: implement
        }

        ~SlidingWindow() {
            // TODO: delete previously allocated stuff (if any)
        }

        /**
         * Makes the window advance one position further.
         * Returns a pointer to the new window head node.
         */
        Node<T> *advance() {
            // TODO: implement
        }

        Node<T> *getWindowHead() {
            return window.getHead();
        }

        template <typename U>
        friend std::ostream& operator<<(std::ostream& os,
                SlidingWindow<U>& window);

 private:
        int capacity;
        std::vector<T> container;
        DoublyLinkedList<T> window;
};

template <typename T>
std::ostream& operator<<(std::ostream& os, SlidingWindow<T>& window) {
    Node<T> *it = window.getWindowHead();

    os << "[ ";
    while (it != nullptr) {
        os << it->data << " ";
        it = it->next;
    }
    os << "]";

    return os;
}


#endif  // SLIDINGWINDOW_H
